/*
 * DFPLAYER_MINI.h
 *
 *  Created on: December 10, 2022
 *  Author:     JM_PALOMINO
 *  Based on :  controllerstech library 
 */

#ifndef INC_DFPLAYER_MINI_H_
#define INC_DFPLAYER_MINI_H_

#define Start_Byte 0x7E
#define End_Byte   0xEF
#define Version    0xFF
#define Cmd_Len    0x06
#define Feedback   0x00    //If need for Feedback: 0x01,  No Feedback: 0
#define Source     0x02  // TF CARD
#define track      0x03//PARA DEFINIR EL NUMERO DE LA PISTA A REPRODUCIR DE 0 A 2999
#define pause      0x0E //PAUSAR REPRODUCCION
#define play       0x0D //REPRODUCIR
#define next       0X01 //SIGUIENTE PISTA
#define previus    0X02 //PISTA ANTERIOR
#define volumen    0x06//VOLUMEN DE AUDIO DESDE 0 HASTA 30
#define vol_up     0x04 //SUBIR VOLUMEN UN PASO A LA VES
#define vol_down   0x05 //BAJAR VOLUMEN UN PASO A LA VES
#define USB_SD     0x09//ESPECIFICA DISPOSITIVO A LEER USB - SD
#define EQ            0x07//Normal : Pop : Rock : Jazz : Classic : Bass
#define repeat_track  0X08//REPITE LA PISTA INDICANDO CUAL DE 0 A 2999
#define repeat_all_tr 0X11//REPITE TODAS PISTA
#define sleep         0x0A //MODULO A DORMIR
#define reset         0x0C//RECETEO DEL DFplayer mini
#define randon        0x18 //PISTAS ALEATORIAS
#define stop          0x16 //DETENER
#define set_DAC       0x1A// SALIDA DAC ENCENDER - APAGAR
#define set_repeat    0x19//REPRODUCCION REPETIDA DE LA PISTA ACTUAL ENCENDER - APAGAR

void Send_cmd (uint8_t cmd, uint8_t Parameter1, uint8_t Parameter2);
void DF_PlayFromStart(void);
void DF_Init (uint8_t volume);
void DF_Volume (uint8_t volume);
void DF_Next (void);
void DF_Pause (void);
void DF_Previous (void);
void DF_Playback (void);
void DF_Randon (void);
void DF_Track (unsigned int pista);

#endif /* INC_DFPLAYER_MINI_H_ */
