/*
 * DFPLAYER_MINI.c
 *
 *  Created on: December 10, 2022
 *  Author:     JM_PALOMINO
 *  Based on :  controllerstech library 
 */

#include "stm32f1xx_hal.h"
#include "usart.h"
#include "stdio.h"
#include "DFPLAYER_MINI.h"

extern UART_HandleTypeDef huart1;
#define DF_UART &huart1


void Send_cmd (uint8_t cmd, uint8_t Parameter1, uint8_t Parameter2)
{
	uint16_t Checksum = Version + Cmd_Len + cmd + Feedback + Parameter1 + Parameter2;
	Checksum = 0-Checksum;

	uint8_t CmdSequence[10] = { Start_Byte, Version, Cmd_Len, cmd, Feedback, Parameter1, Parameter2, (Checksum>>8)&0x00ff, (Checksum&0x00ff), End_Byte};

	HAL_UART_Transmit(DF_UART, CmdSequence, 10, HAL_MAX_DELAY);
}

void DF_PlayFromStart(void)
{
  Send_cmd(0x03,0x00,0x01);
  HAL_Delay(200);
}


void DF_Init (uint8_t volume)
{
	Send_cmd(0x3F, 0x00, Source);
	HAL_Delay(200);
	Send_cmd(0x06, 0x00, volume);
	HAL_Delay(500);
}

void DF_Volume(uint8_t volume)
{
	Send_cmd(0x06, 0x00, volume);
	HAL_Delay(200);
}

void DF_Next (void)
{
	Send_cmd(next, 0x00, 0x00);
	HAL_Delay(200);
}

void DF_Pause (void)
{
	Send_cmd(pause , 0, 0);
	HAL_Delay(200);
}

void DF_Previous (void)
{
	Send_cmd(previus, 0, 0);
	HAL_Delay(200);
}

void DF_Playback (void)
{
	Send_cmd(play, 0, 0);
	HAL_Delay(200);
}

void DF_Randon(void)
{
	Send_cmd(randon , 0, 0);
	HAL_Delay(200);
}

void DF_Track (unsigned int pista)
{
	Send_cmd(track,(pista >> 8)&0x00FF,(pista&0x00FF));
	HAL_Delay(200);
}














