/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2024 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "i2c.h"
#include "tim.h"
#include "usart.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include <stdio.h>
#include "nec_ir.h"
#include "lcd.h" 
#include "DFPLAYER_MINI.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */
#define LOW      GPIO_PIN_RESET 
#define HIGH     GPIO_PIN_SET 
#define limit    2999

/*
!READ THIS
***********************************************************************************
The DF player can play up to 3000 tracks (0-2999), 
if you are gonna not use all the DF player capacity then is necessary set a limit 
Because otherwise the DF player will jump from track to track ,indefinitely
************************************************************************************
*/

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */
uint32_t ir_code=0; 
signed int cancion=0;
uint8_t Trk=0, pp=0, aux=0, vt=0, clr=0, pv=0, chg=0;
signed char vol=0;
char strg[18]; 
char num[4]; 
/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
void show_track(signed int count) {
	
char num[4];
uint8_t env=0, fila=10;	
	
if(count<0)	count=limit, cancion=limit;		
if(count>limit) count =0, cancion=0;	

I2C_LCD_Cmd(_LCD_CLEAR);
I2C_LCD_Out(1,5,"DF_PLAYER");	
I2C_LCD_Out(2,1,"TRACK");
	
	  for(env=0; env<=3; env++) {
            num[0] =  count/1000;
            num[1] = (count/100)%10;
            num[2] = (count/10)%10;
            num[3] =  count%10;
            I2C_LCD_Chr(2,fila,num[env]+48);
            fila++;
            if(fila>13)fila=10;
    }
}

void show_vol(signed char count1) {
	
char chr;
	
if((count1>30)||(count1<0)) count1=0, vol=0;
	
I2C_LCD_Cmd(_LCD_CLEAR);
I2C_LCD_Out(1,5,"DF_PLAYER");		
I2C_LCD_Out(2,1,"VOLUME");	
chr =count1/10;	
I2C_LCD_Chr(2,10,chr+48);	
chr =count1%10;
I2C_LCD_Chr(2,11,chr+48);	
	  
}
/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */
  
  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_I2C1_Init();
  MX_TIM1_Init();
  MX_USART1_UART_Init();
  /* USER CODE BEGIN 2 */
   NEC_Init();
	 I2C_LCD_Init();
   I2C_LCD_Cmd(_LCD_CURSOR_OFF);
   I2C_LCD_Cmd(_LCD_CLEAR);
	 I2C_LCD_Out(1,5,"DF_PLAYER"); 
	 DF_Init(10);
   DF_PlayFromStart();
	 HAL_Delay(100); 
	 
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */
	if((HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_0)==HIGH)&& (pp==0)){
			HAL_Delay(100);
		if((HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_0)==HIGH)&& (pp==0)){
			cancion++;
		  if(cancion<0)	cancion=limit;	//you must 	
			if(cancion>limit) cancion=0;
		  DF_Track (cancion);
		  show_track(cancion);
			HAL_Delay(100);
		}		
	}	
		if(NEC_Available() > 0)
		{
			
			ir_code = NEC_Get_Code();
			switch (ir_code) {
				
           case (0xFFA25D):
						 Trk=1;     
		       break;
			
		       case (0xFF629D):
						 Trk=2;         
		       break;
		 
		       case (0xFFE21D):
						  Trk=3; 
		       break;

	       case (0xFF22DD):
					   Trk=4; 
		     break;
				 
				 case (0xFF02FD):
					   Trk=5; 
		     break;

	       case (0xFFC23D):
					   Trk=6; 
		     break;

	      case (0xFFE01F):
					    Trk=7; 
		     break;

	     case (0xFFA857):
				   Trk=8; 
		   break;

	     case (0xFF906F):
				   Trk=9; 
		   break;

	    case (0xFFB04F):
		   //"#"
			aux++; 	
		  break;
 
	   case (0XFF6897):
		   //"*"
		 	   Trk=1;
         clr=1; 		 
		 break;			
						
	   case (0xFF9867):
			   Trk=0; 
		  break;

	  case (0xFF38C7):
		  //"OK"
		 pv=1;
		 break;

	  case (0xFF18E7):
	  //"UP"
		 cancion++;
	   aux=0; 
		 DF_Track(cancion);
		 pv=2;
		break;
			
	  case (0xFF10EF):
	   //"LEFT"
		  vol--;
		  aux=1;
		  DF_Volume(vol);
		  pv=2;
		break;			

	  case (0xFF5AA5):
	   //"RIGHT"
		  vol++; 
		  aux=1;
      DF_Volume(vol);
		  pv=2;
		break;
			
	   case (0xFF4AB5):
	    //"DOWN"
		  cancion--;
		  aux=0; 
		  DF_Track(cancion);
		  pv=2;
		 break;
			
	   default :
		  break;
    } 
			
		if(aux>2) aux=0; 
		
		if (aux==0)	{
			if(pv==1)DF_Track(cancion), cancion=cancion/10, pv=0;
			if(clr==1) cancion=0, Trk=0, clr=0;					
			if(pv==0)cancion=(10*cancion)+Trk;
      if(cancion<0)	cancion=limit;		
			if(cancion>limit) cancion =0;
			if(pv==2)pv=0;
			show_track(cancion);
			chg=1;
		 }	
    if(aux==1)	{
			if(chg==1)Trk=0, chg=2;
			if(pv==1) DF_Volume(vol), vol=vol/10, pv=0;
			if(clr==1) vol=0, Trk=0, clr=0;	
		  if(pv==0)vol=(10*vol)+Trk;
		  if((vol>30)||(vol<0))vol=0;
			if(pv==2)pv=0;
		  show_vol(vol);
    }
		
		if(aux==2)	{
			 I2C_LCD_Out(2,1,"PAUSE_1_PLAY_2_");
			 cancion=0;
			 vol=0;
			 if(chg==2) Trk=0, chg=0;
			 if(Trk==1) DF_Pause(), pp=1,   Trk=0;
			 if(Trk==2) DF_Playback(),pp=0, Trk=0;
    }
  }	
	
 }
    /* USER CODE BEGIN 3 */
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
