
#include "main.h"
#include "tim.h"
#include "nec_ir.h"

#define PIN_IR_NEC GPIO_PIN_12
#define tim_nec htim1

uint32_t code_temp;
uint8_t bit_counter;
uint8_t cmd_h;
uint8_t cmd_l;
uint8_t flag_ir = 0;

void NEC_Init(void)
{
	 HAL_TIM_Base_Start(&tim_nec);
	 __HAL_TIM_SetCounter(&tim_nec, 0);
}

uint8_t NEC_Available(void)
{
	return flag_ir;
}

uint32_t NEC_Get_Code(void)
{
	flag_ir = 0;
	return code_temp;
}

void HAL_GPIO_EXTI_Callback(uint16_t GPIO_Pin)
{
	if(GPIO_Pin == PIN_IR_NEC)
	{
		if(__HAL_TIM_GetCounter(&tim_nec) > 8000)
		{
			code_temp = 0;
			bit_counter = 0;
		}
		else if (__HAL_TIM_GetCounter(&tim_nec) > 1700)
		{
			code_temp |= (1UL << (31-bit_counter));
			bit_counter++;
		}
		else if (__HAL_TIM_GetCounter(&tim_nec) > 1000)
		{
			code_temp &= ~(1UL << (31-bit_counter));
			bit_counter++;
		}

		if(bit_counter == 32)
		{
			cmd_l = ~code_temp;
			cmd_h = code_temp >> 8;
			if(cmd_l == cmd_h)
			{
				flag_ir = 1;
			}
			bit_counter = 0;
		}
		__HAL_TIM_SetCounter(&tim_nec, 0);
	}
}
